<?php
/*------------------------------------------------------------------------
# mod_wpposts - WordPress Posts
# ------------------------------------------------------------------------
# author    Joomla!Vargas
# copyright Copyright (C) 2010 joomla.vargas.co.cr. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://joomla.vargas.co.cr
# Technical Support:  Forum - http://joomla.vargas.co.cr/forum
-------------------------------------------------------------------------*/

defined('_JEXEC') or die;

abstract class modWpPostsHelper
{
	public static function getList($db, &$params)
	{
		$ptype       = $params->get('post-type');
		$count		 = (int) $params->get('count', 5);
		$catids  	 = trim( $params->get('catids', '') );

		$where		= 'a.post_status = \'publish\'';
		$left_join  = '';
		$group_by   = '';
 
		switch ($ptype)
		{
			case 'page':
				$where .= ' AND a.post_type=\'page\'';
				break;
				
			case 'post':
				default:
				$where .= ' AND a.post_type=\'post\'';
		}

		switch ($params->get( 'order' ))
		{
			case 'comments':
				$ordering		= 'a.comment_count DESC, a.post_title ASC';
				break;
			case 'title-desc':
				$ordering		= 'a.post_title DESC, a.post_date DESC';
				break;
			case 'title-asc':
				$ordering		= 'a.post_title ASC, a.post_date DESC';
				break;
			case 'm_latests':
				$ordering		= 'a.post_modified DESC,a.post_modified DESC';
				break;
			case 'c_latests':
			default:
				$ordering		= 'a.post_date DESC,a.post_title ASC';
				break;
		}
		
		if ( $catids && $ptype == 'post' ) :
			$left_join = ' LEFT JOIN #__term_relationships c ON a.ID = c.object_id';
			$cats = explode( ',', $catids );
			JArrayHelper::toInteger( $cats );
			$where .= ' AND (c.term_taxonomy_id=' . implode( ' OR c.term_taxonomy_id=', $cats ) . ')';
			$group_by = ' GROUP BY a.ID';
		endif;

		// Create the SQL query to get posts for WordPress
		$query = 'SELECT a.ID,a.post_type,a.post_title,a.post_content,a.post_date' .
			' FROM #__posts AS a' .
		    $left_join .
			' WHERE '. $where .
		    $group_by .
			' ORDER BY '. $ordering;
		$db->setQuery($query, 0, $count); 
		//echo preg_replace('/#__/', 'wp_', $query);

        $rows = $db->loadObjectList();
		
		if (count($rows)) {
			
			$show_text	  = trim( $params->get('show_text', 1) );
			$limit_text	  = trim( $params->get('limit_text', 150) );
			$readmore     = $params->get('readmore', 0);
			$allowedtags  = $params->get('allowedtags', '');
			$target       = $params->get('target','_blank');
			$layout       = $params->get('layout','_:default_');
			$show_date    = $params->get('show_date', 0);

			$img_feat     = $params->get('img_feat', 1);			
			$img_align 	  = $params->get( 'img_align', 'left' );
			$img_margin   = $params->get( 'img_margin', '3px' );
			$img_width 	  = (int)$params->get( 'img_width', 90 );
			$img_height   = (int)$params->get( 'img_height', 0 );
			$img_class    = $params->get( 'img_class', '0' );

			$thumb_image  = $params->get('thumb_image', 1);			
			$thumb_prop   = $params->get('thumb_proportions','bestfit');
			$thumb_type   = $params->get('thumb_type','');
			$thumb_bg     = hexdec($params->get('thumb_bg','#FFFFFF'));

			$i            = 0;
			$lists        = array();
			
			$db->setQuery('SELECT option_value FROM #__options WHERE option_name = ' . $db->quote('siteurl'));
			$siteurl = $db->loadResult();
	
			foreach ( $rows as &$row )
			{
				if ($row->post_type == 'post') {
					$row->link = $siteurl.'/?p='.$row->ID;
				} else {
					$row->link = $siteurl.'/?page_id='.$row->ID;
				}
				$row->title    = htmlspecialchars( $row->post_title );
				$row->content  = '';
				$row->readmore = 0;
				
				if ( $layout != '_:list' ) :
					
					if ( $show_text ) :
						$text = $row->post_content;
						if ( $show_text == 1 ) :
							$text = trim( strip_tags(  $text, $allowedtags ) );
							$text = preg_replace("/\[caption.+caption\]/", "", $text);
							if ( $limit_text && strlen( $text ) > $limit_text ) :
							   $text  = substr( $text, 0, $limit_text );
							   $space = strrpos( $text, ' ' );
							   $text  = substr( $text, 0, $space ). '...';
							   $row->readmore = 1;
							endif;
						else :
							if ( preg_match('/<!--more(.*?)?-->/', $text, $matches) ) :
								$parts = explode($matches[0], $text);
								$text  = $parts[0];
							endif;
							if ($show_text == 3) :
								//$regex   = "/<img[^>]+src\s*=\s*[\"']\/?([^\"']+)[\"'][^>]*\>/";
								$regex   = "/(<a[^>]+>\s*)?<img[^>]+src\s*=\s*[\"']\/?([^\"']+)[\"'][^>]*\>(\s*<\/a>)?/";
								$text = preg_replace ($regex, '', $text);
							endif;
							$row->readmore = 1;
						endif;
						$row->content  = $text;
						if ( $readmore && $row->readmore ) :
							$row->content .= '<a href="'.$row->link.'" target="'.$target.'" class="readmore">'.JText::_('MOD_WPPOSTS_READMORE').' </a>';
						endif;
					endif;				
					
					$row->image       = '';	
					$row->displayDate = '';				
					
					if ( $img_align ) :
						$img = '';
						if ( $img_feat ) {
							$query = 'SELECT a.meta_value' .
								' FROM #__postmeta a' .
								' LEFT JOIN #__postmeta b ON b.meta_value = a.post_id' .
								' WHERE a.meta_key = ' . $db->quote('_wp_attached_file') .
								' AND b.post_id = ' . $row->ID
							;
							$db->setQuery($query);
							$img = $db->loadResult();
							if ($img ) {
								$img = $siteurl . '/wp-content/uploads/' . $img;
							}
						}
						
						if (!$img) {					
							$regex   = "/<img[^>]+src\s*=\s*[\"']\/?([^\"']+)[\"'][^>]*\>/";
							$search  = $row->post_content;
							preg_match ($regex, $search, $matches);
							$images = (count($matches)) ? $matches : array();
							if ( count($images) ) {
								$img = $images[1];
							}
						}
						if ($img) {
							if ($thumb_image) {
								$img = str_replace(JURI::base(false),'',$img);
								$img = modWpPostsHelper::getThumbnail($img,$params,$row->ID,$img_width,$img_height,$thumb_prop,$thumb_type,$thumb_bg); 
							}
							$row->image  = modWpPostsHelper::getImg ($img,$img_align,$img_margin,$img_width,$img_height,$img_class);
						}
						
					endif;
					
					if ( $show_date ) :
						$row->displayDate = JHTML::_('date', $row->post_date, $params->get('date_format', ''));
					endif;
					
				endif;
				
				$i++;
			}
		}

		return $rows;
	}
	
	public static function getImg( $img,$align,$margin,$width,$height,$class ) {
			
		if ( $align == 'left' )  :
			   $style = 'float:left; margin-right:' . $margin . ';';
		endif;
		
		if ( $align == 'right' )  :
		   $style = 'float:right; margin-left:' . $margin . ';';
		endif;
			
		$attribs = array ('style' => $style);
		
		if ( $class )
			$attribs[] = array('class' => $class);
			
		if ( !strpos($img, 'modules/mod_wpposts/thumbs') ) {
			if ( $height )
				$attribs[] = array('height' => $height);
			
			if ( $width )
				$attribs[] = array('width' => $width);
		}
		
		$image = JHTML::_('image', $img, '', $attribs );
					
		return $image;
	}
	
	public static function getThumbnail($img,&$params,$postid,$width,$height,$proportion,$img_type,$bgcolor) 
	{
		
		$size = @getimagesize($img);
		
		if(!$size) 
		{	
			return $img;
		
		} else {
					
			$img_name   = pathinfo($img, PATHINFO_FILENAME);
			$img_ext    = pathinfo($img, PATHINFO_EXTENSION);
							
			$folder     = '0' . substr($postid, -1);
							
			if ( $img_type ) {
				$img_ext = $img_type;
			}
	
			$origw = $size[0];
			$origh = $size[1];
			if( ($origw<$width && $origh<$height)) {
				$width = $origw;
				$height = $origh;
			}
			
			$prefix = substr($proportion,0,1) . "_".$width."_".$height."_".$bgcolor."_".$postid."_";
	
			$thumb_file = $prefix . str_replace(array( ':', '/', '\\', '?', '&', '%20', ' '),  '_' ,$img_name . '.' . $img_ext);		
			
			$thumb_path = dirname(__FILE__).'/thumbs/' . $folder . '/' . $thumb_file;
			
			if(!file_exists($thumb_path))	{
				
				$errors = array();
		
				modWpPostsHelper::calculateSize($origw, $origh, $width, $height, $proportion, $newwidth, $newheight, $dst_x, $dst_y, $src_x, $src_y, $src_w, $src_h);
	
				switch(strtolower($size['mime'])) {
					case 'image/png':
						$imagecreatefrom = "imagecreatefrompng";
						break;
					case 'image/gif':
						$imagecreatefrom = "imagecreatefromgif";
						break;
					case 'image/jpeg':
						$imagecreatefrom = "imagecreatefromjpeg";
						break;
					default:
						$errors[] = "Unsupported image type $img_name.$img_ext ".$size['mime'];
				}
	
				
				if ( !function_exists ( $imagecreatefrom ) ) {
					$errors[] = "Failed to process $img_name.$img_ext. Function $imagecreatefrom doesn't exist.";
				}
				
				$src_img = $imagecreatefrom($img);
				
				if (!$src_img) {
					$errors[] = "There was a problem to process image $img_name.$img_ext ".$size['mime'];
				}
				
				$dst_img = ImageCreateTrueColor($width, $height);
				
				// $bgcolor = imagecolorallocatealpha($image, 200, 200, 200, 127);
				
				imagefill( $dst_img, 0,0, $bgcolor);
				if ( $proportion == 'transparent' ) {
					imagecolortransparent($dst_img, $bgcolor);
				}
				
				imagecopyresampled($dst_img,$src_img, $dst_x, $dst_y, $src_x, $src_y, $newwidth, $newheight, $src_w, $src_h);		
				
				switch(strtolower($img_ext)) {
					case 'png':
						$imagefunction = "imagepng";
						break;
					case 'gif':
						$imagefunction = "imagegif";
						break;
					default:
						$imagefunction = "imagejpeg";
				}
				
				if($imagefunction=='imagejpeg') {
					$result = @$imagefunction($dst_img, $thumb_path, 80 );
				} else {
					$result = @$imagefunction($dst_img, $thumb_path);
				}
	
				imagedestroy($src_img);
				if(!$result) {				
					if(!$disablepermissionwarning) {
					$errors[] = 'Could not create image:<br />' . $thumb_path . '.<br /> Check if the folder exists and if you have write permissions:<br /> ' . dirname(__FILE__) . '/thumbs/' . $folder;
					}
					$disablepermissionwarning = true;
				} else {
					imagedestroy($dst_img);
				}
				if (count($errors)) {
					JError::raiseWarning(404, implode("\n", $errors));
					return false;
				}
			}			
		}
		
		$image = JURI::base(false)."modules/mod_wpposts/thumbs/$folder/" . basename($thumb_path);
		
		return  $image;
    }
	
	public static function calculateSize($origw, $origh, &$width, &$height, &$proportion, &$newwidth, &$newheight, &$dst_x, &$dst_y, &$src_x, &$src_y, &$src_w, &$src_h) {
		
		if(!$width ) {
			$width = $origw;
		}

		if(!$height ) {
			$height = $origh;
		}

		if ( $height > $origh ) {
			$newheight = $origh;
			$height = $origh;
		} else {
			$newheight = $height;
		}
		
		if ( $width > $origw ) {
			$newwidth = $origw;
			$width = $origw;
		} else {
			$newwidth = $width;
		}
		
		$dst_x = $dst_y = $src_x = $src_y = 0;

		switch($proportion) {
			case 'fill':
			case 'transparent':
				$xscale=$origw/$width;
				$yscale=$origh/$height;

				if ($yscale<$xscale){
					$newheight =  round($origh/$origw*$width);
					$dst_y = round(($height - $newheight)/2);
				} else {
					$newwidth = round($origw/$origh*$height);
					$dst_x = round(($width - $newwidth)/2);

				}

				$src_w = $origw;
				$src_h = $origh;
				break;

			case 'crop':

				$ratio_orig = $origw/$origh;
				$ratio = $width/$height;
				if ( $ratio > $ratio_orig) {
					$newheight = round($width/$ratio_orig);
					$newwidth = $width;
				} else {
					$newwidth = round($height*$ratio_orig);
					$newheight = $height;
				}
					
				$src_x = ($newwidth-$width)/2;
				$src_y = ($newheight-$height)/2;
				$src_w = $origw;
				$src_h = $origh;				
				break;
				
 			case 'only_cut':
				// }
				$src_x = round(($origw-$newwidth)/2);
				$src_y = round(($origh-$newheight)/2);
				$src_w = $newwidth;
				$src_h = $newheight;
				
				break; 
				
			case 'bestfit':
				$xscale=$origw/$width;
				$yscale=$origh/$height;

				if ($yscale<$xscale){
					$newheight = $height = round($width / ($origw / $origh));
				}
				else {
					$newwidth = $width = round($height * ($origw / $origh));
				}
				$src_w = $origw;
				$src_h = $origh;	
				
				break;
		}

	}
	
}
