<?php
/*
* Module Mod_WWPosts For Joomla 1.5.x
* Version		: 1.0.0
* Created by	: Jesus Vargas
* License : GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modWpPostsHelper
{
	function getList($db, $params)
	{
		$ptype      = $params->get('post-type');
		$count		= (int) $params->get('count', 5);
		$catids  	= trim( $params->get('catids', '') );
		$limit_text	= trim( $params->get('limit_text') );
		$wpBaseUrl  = $params->get('wp-root-url');		

		$where		= 'a.post_status = \'publish\'';
		$left_join  = '';
		$group_by   = '';
 
		switch ($ptype)
		{
			case 'page':
				$where .= ' AND a.post_type=\'page\'';
				break;
				
			case 'post':
				default:
				$where .= ' AND a.post_type=\'post\'';
		}

		switch ($params->get( 'order' ))
		{
			case 'comments':
				$ordering		= 'a.comment_count DESC, a.post_title ASC';
				break;
			case 'title-desc':
				$ordering		= 'a.post_title DESC, a.post_date DESC';
				break;
			case 'title-asc':
				$ordering		= 'a.post_title ASC, a.post_date DESC';
				break;
			case 'm_latests':
				$ordering		= 'a.post_modified DESC,a.post_modified DESC';
				break;
			case 'c_latests':
			default:
				$ordering		= 'a.post_date DESC,a.post_title ASC';
				break;
		}
		
		if ( $catids && $ptype == 'post' ) :
			$left_join = ' LEFT JOIN #__term_relationships c ON a.ID = c.object_id';
			$cats = explode( ',', $catids );
			JArrayHelper::toInteger( $cats );
			$where .= ' AND (c.term_taxonomy_id=' . implode( ' OR c.term_taxonomy_id=', $cats ) . ')';
			$group_by = ' GROUP BY a.ID';
		endif;

		// Create the SQL query to get posts for WordPress
		$query = 'SELECT a.ID,a.post_type,a.post_title,a.post_content ' .
			' FROM #__posts AS a' .
		    $left_join .
			' WHERE '. $where .
		    $group_by .
			' ORDER BY '. $ordering;
		$db->setQuery($query, 0, $count); 
		//echo preg_replace('/#__/', 'wp_', $query);

        $rows = $db->loadObjectList();

		$i          = 0;
		$lists      = array();

        // Remove the trailing slash from the url (if any)
		if (substr($wpBaseUrl, -1) == '/') {
			$wpBaseUrl = substr($wpBaseUrl, 0 ,-1);
		}
		foreach ( $rows as $row )
		{
			if ($row->post_type == 'post') {
				$lists[$i]->link = $wpBaseUrl.'/?p='.$row->ID;
			} else {
				$lists[$i]->link = $wpBaseUrl.'/?page_id='.$row->ID;
			}
			$lists[$i]->title = htmlspecialchars( $row->post_title );
			$lists[$i]->readmore = false;
			
			if ( $params->get('format','default') != 'list' ) :
			
				$text = trim( strip_tags(  $row->post_content, $params->get('allowedtags', '') ) );
				$text = preg_replace("/\[caption.+caption\]/", "", $text);
				if ( $limit_text && strlen( $text ) > $limit_text ) :
				   $text  = substr( $text, 0, $limit_text );
				   $space = strrpos( $text, ' ' );
				   $text  = substr( $text, 0, $space ). '...';
					if ($params->get('readmore')) :
						$lists[$i]->readmore = true;
					endif;
				endif;
				$lists[$i]->content  = $text;
				
				$lists[$i]->image = '';
				
				if ( $params->get('img_align') ) :
					$regex   = "/<img[^>]+src\s*=\s*[\"']\/?([^\"']+)[\"'][^>]*\>/";
					$search  = $row->post_content;
					preg_match ($regex, $search, $matches);
					$images = (count($matches)) ? $matches : array();
					if ( count($images) ) {
					  $lists[$i]->image  = modWpPostsHelper::getImg ( $params, $images[1] );
					}
				endif;
				
			endif;
			
			$i++;
		}

		return $lists;
	}
	
	function getImg( &$params, $img ) {
	
		$align 	    = $params->get( 'img_align', 'left' );
		$margin 	= $params->get( 'img_margin', '3px' );
		$width 		= (int)$params->get( 'img_width', '' );
		$height 	= (int)$params->get( 'img_height', '' );
		$class		= $params->get( 'img_class', '0' );
		
		if ( $align == 'left' )  :
			   $style = 'float:left; margin-right:' . $margin . ';';
		endif;
		
		if ( $align == 'right' )  :
		   $style = 'float:right; margin-left:' . $margin . ';';
		endif;
			
		$attribs = array ('target' => '_blank', 'style' => $style);
		
		if ( $class )
			$attribs[] = array('class' => $class);
			
		if ( $height )
			$attribs[] = array('height' => $height);
		
		if ( $width )
			$attribs[] = array('width' => $width);
		
		$image = JHTML::_('image', $img, JText::_('IMAGE'), $attribs );
					
		return $image;
	}
}
